<?php
/* 
 * parseHtml.php 
 * Author: Carlos Costa Jordao 
 * Email: carlos@radiumsystems.com.br 
 * 
 * My notation of variables: 
 * i_ = integer, ex: i_count 
 * a_ = array,       a_html 
 * b_ = boolean, 
 * s_ = string 
 * 
 * What it does: 
 * - parses a html string and get the tags 
 *   - exceptions: html tags like <br> <hr> </a>, etc 
 * - At the end, the array will look like this: 
 *      ["IMG"][0]["SRC"] = "xxx" 
 *      ["IMG"][1]["SRC"] = "xxx" 
 *      ["IMG"][1]["ALT"] = "xxx" 
 *      ["A"][0]["HREF"] = "xxx" 
 * 
 */ 

class KCHtmlParse
{
        var $m_ParseTag = array() ;             //parsing ϴ ±׸  

        function m_ParseHtml( $s_str ) 
        { 
                $i_indicatorL = 0;      //±  ġ 
                $i_indicatorR = 0;      // ±  ġ 
                $s_tagOption = "";      // ±  ִ attribute  
                $i_arrayCounter = 0;    //
                $a_html = array(); 
                // Search for a tag in string 
                // $s_str $i_indicatorR "<"  ±׸ ã   
                // $_iindicatorL Ѵ. 
                
                // loop 
                while( is_int(($i_indicatorL=strpos($s_str,"<",$i_indicatorR))) ) 
                { 
                        // Get everything into tag... 
                        
                        // tag ۹ڸ ؼ $i_indicattorL ϳ  
                        $i_indicatorL++; 
                        
                        //±  ã   Ѵ. 
                        $i_indicatorR = strpos($s_str,">", $i_indicatorL); 
                        
                        
                        //±   $s_temp  
                        $s_temp = substr($s_str, $i_indicatorL, ($i_indicatorR-$i_indicatorL)); 
                        
                        // ڷ ؼ ±   
                        $a_tag = explode( ' ', $s_temp ); 
                        
                        // Here we get the tag's name ± ̸  
                        list( ,$s_tagName,, ) = each($a_tag);                        
                        $s_tagName = strtoupper($s_tagName); 
                        

                        //tag parsing ϴ ±׿ Ѵٸ Ľ Ѵ.                         
                        if(in_array(strtolower($s_tagName), $this->m_GetParseTag() ))
                        {
                                // Well, I am not interesting in <br>, </font> or anything else like that... 
                                // So, this is false for tags without options. 
        
                                $b_boolOptions = is_array(($s_tagOption=each($a_tag))) && $s_tagOption[1] ;
                                if( $b_boolOptions ) 
                                { 
                                        // Without this, we will mess up the array 
                                        $i_arrayCounter = (int)count($a_html[$s_tagName]); 
                                        // get the tag options, like src="htt://". Here, s_tagTokOption is 'src' and s_tagTokValue is '"http://"' 
                                        do 
                                        { 
                                                //key=vlaue и
                                                $tagOption = split("=", $s_tagOption[1] ,2 );                                          
                                                //KLUDGE : href  value ü "="    split ؼ װ ߶
                                                //       '/Board/guest_list.php?tb=jiwookye&pageNumber=3'   strtok ̿ؼ ó   
                                                //
                                                // Old Code 
                                                //$s_tagTokOption = trim(strtoupper(strtok($s_tagOption[1], "="))); 
                                                //$s_tagTokValue  = trim(strtok("=")); 
                                                
                                                $s_tagTokOption = trim(strtoupper($tagOption[0])); //attribute name 
                                                $s_tagTokValue = trim($tagOption[1]) ;             // attribute value 

                                                $a_html[$s_tagName][$i_arrayCounter][$s_tagTokOption] = trim($s_tagTokValue); 
                                                $b_boolOptions = is_array(($s_tagOption=each($a_tag))) && $s_tagOption[1]; 
                                        } while( $b_boolOptions ); 
                                } 
                        }
                        
                } 
                return $a_html; 
        } 
        
        //------------------------------------------------------------------------ 
        // parsing ϴ ±׸ մϴ.
        // ʵ   · Ѿ͵  ','  ˴ϴ. 
        //  ) $sql->m_SetParseTag("na"); <-         
        //      $sql->m_SetParseTag("na, Jong") ; <-  
        //      $sql->m_SetParseTag("na, jong ", "sung, konlo ") ; <-  
        //------------------------------------------------------------------------ 
        function m_SetParseTag()
        {
                $start_index = count($this->m_ParseTag);               
                
                //Ѿ arg ʷ parsing   
                for($i = 0 ; $i < func_num_args() ; $i ++)
                {
                        // arg ٽ ',' и Ͽ Ÿ                         
                        $tag = func_get_arg($i) ;
                        $tag = explode(",", $tag );
                        for($j = 0 ; $j < count($tag) ; $j ++)
                        {
                                $this->m_ParseTag[$start_index++] =trim($tag[$j]);
                        }
                }
        }
        
        
        //------------------------------------------------------------------------ 
        // ParseTag  ȯ  
        //------------------------------------------------------------------------ 
        function m_GetParseTag()
        {
                return $this->m_ParseTag ;
        }
        
}
?>